//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%42249A6D009F.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%42249A6D009F.cm

//## begin module%42249A6D009F.cp preserve=no
//## end module%42249A6D009F.cp

//## Module: Bayes%42249A6D009F; Package body
//## Subsystem: XSFit::Fit%3677C9158350
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSFit/Fit/Bayes.cxx

//## begin module%42249A6D009F.additionalIncludes preserve=no
//## end module%42249A6D009F.additionalIncludes

//## begin module%42249A6D009F.includes preserve=yes
//## end module%42249A6D009F.includes

// Fit
#include <XSFit/Fit/Fit.h>
// Bayes
#include <XSFit/Fit/Bayes.h>


//## begin module%42249A6D009F.declarations preserve=no
//## end module%42249A6D009F.declarations

//## begin module%42249A6D009F.additionalDeclarations preserve=yes
#include <XSModel/Parameter/ModParam.h>
#include <XSUtil/Error/Error.h>
#include <sstream>
//## end module%42249A6D009F.additionalDeclarations


// Class Bayes 

Bayes::Bayes()
  //## begin Bayes::Bayes%42249B3C01E8_const.hasinit preserve=yes
  : m_isOn(false)
  //## end Bayes::Bayes%42249B3C01E8_const.hasinit
  //## begin Bayes::Bayes%42249B3C01E8_const.initialization preserve=yes
  //## end Bayes::Bayes%42249B3C01E8_const.initialization
{
  //## begin Bayes::Bayes%42249B3C01E8_const.body preserve=yes
  //## end Bayes::Bayes%42249B3C01E8_const.body
}


Bayes::~Bayes()
{
  //## begin Bayes::~Bayes%42249B3C01E8_dest.body preserve=yes
  //## end Bayes::~Bayes%42249B3C01E8_dest.body
}



//## Other Operations (implementation)
Real Bayes::lPrior (Fit* fit) const
{
  //## begin Bayes::lPrior%4224A348036D.body preserve=yes
   // Routine to return the sum of the  log of the priors for all 
   // the fit parameters.
   Real result = .0;
   // If not in Bayesian inference mode, return 0.
   if (m_isOn)
   {
      std::map<int,ModParam*>::const_iterator it = 
                fit->variableParameters().begin();
      std::map<int,ModParam*>::const_iterator itEnd = 
                fit->variableParameters().end();
      while (it != itEnd)
      {
         const ModParam* modPar = it->second;
         if (modPar->priorType() == ModParam::CONS)
         {
            // do nothing?
         }
         else if (modPar->priorType() == ModParam::EXP)
         {
            Real hyper = modPar->hyperParam();
            result -= modPar->value('v')/hyper + std::log(hyper);
         }
         ++it;
      }
   }
   return result;
  //## end Bayes::lPrior%4224A348036D.body
}

Real Bayes::dlPrior (Fit* fit, const int iPar) const
{
  //## begin Bayes::dlPrior%4224A3B001AF.body preserve=yes
   // Routine to return the derivative wrt iPar of the log  
   // of the prior probability for that parameter.
   Real result = .0;
   // If not in Bayesian inference mode, return 0.
   if (m_isOn)
   {
      const ModParam* modPar = fit->variableParameters(iPar);
      if (!modPar)
      {
         std::ostringstream msg;
         msg <<"Bayes::dlPrior: Unable to locate param idx " << iPar 
                << " among Fit params.";
         throw YellowAlert(msg.str());
      }
      
      if (modPar->priorType() == ModParam::EXP)
      {
         // Of course hyperParam had better not be 0 by this point.
         result = -1.0/modPar->hyperParam();
      }
      // else do nothing
   }
   return result;
  //## end Bayes::dlPrior%4224A3B001AF.body
}

Real Bayes::d2lPrior (Fit* fit, const int iPar, const int jPar) const
{
  //## begin Bayes::d2lPrior%4224A3EA000E.body preserve=yes
   // Routine to return the second derivative wrt iPar and 
   // jPar of the log of the prior probability for that 
   // parameter. This will be zero unless iPar=jPar or the
   // prior probability of the parameters is linked.
   Real result = .0;
   if (m_isOn)
   {
      const ModParam* modPar = fit->variableParameters(iPar);
      if (!modPar)
      {
         std::ostringstream msg;
         msg <<"Bayes::d2lPrior: Unable to locate param idx " << iPar 
                << " among Fit params.";
         throw YellowAlert(msg.str());
      }
      
   }
   return result;
  //## end Bayes::d2lPrior%4224A3EA000E.body
}

// Additional Declarations
  //## begin Bayes%42249B3C01E8.declarations preserve=yes
  //## end Bayes%42249B3C01E8.declarations

//## begin module%42249A6D009F.epilog preserve=yes
//## end module%42249A6D009F.epilog
